"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _resolveDebugLevels = _interopRequireDefault(require("resolve-debug-levels"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const log = (0, _resolveDebugLevels.default)('resolve:resolve-readmodel-postgresql-serverless:begin-transaction');

const beginTransaction = async (pool, readModelName) => {
  try {
    log.verbose('Begin transaction to postgresql database started');

    if (pool.transactionId != null) {
      try {
        await pool.rollbackTransaction(pool.transactionId);
      } catch (error) {}
    }

    const {
      transactionId
    } = await pool.rdsDataService.beginTransaction({
      resourceArn: pool.dbClusterOrInstanceArn,
      secretArn: pool.awsSecretStoreArn,
      database: 'postgres'
    });

    if (transactionId == null) {
      throw new Error('Begin transaction returned null transactionId');
    }

    pool.transactionId = transactionId;
    pool.readModelName = readModelName;
    log.verbose('Begin transaction to postgresql database succeed');
  } catch (error) {
    log.verbose('Begin transaction to postgresql database failed', error);
    throw error;
  }
};

var _default = beginTransaction;
exports.default = _default;
//# sourceMappingURL=begin-transaction.js.map