"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _resolveDebugLevels = _interopRequireDefault(require("resolve-debug-levels"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const log = (0, _resolveDebugLevels.default)('resolve:resolve-readmodel-postgresql-serverless:rollback-transaction');

const rollbackTransaction = async pool => {
  try {
    log.verbose('Rollback transaction to postgresql database started');
    await pool.rdsDataService.rollbackTransaction({
      resourceArn: pool.dbClusterOrInstanceArn,
      secretArn: pool.awsSecretStoreArn,
      transactionId: pool.transactionId
    });
    log.verbose('Rollback transaction to postgresql database succeed');
  } catch (error) {
    log.verbose('Rollback transaction to postgresql database failed', error);
    throw error;
  } finally {
    pool.transactionId = null;
  }
};

var _default = rollbackTransaction;
exports.default = _default;
//# sourceMappingURL=rollback-transaction.js.map